apeman-app-sign
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]

[bd_repo_url]: https://github.com/apeman-app-labo/apeman-app-sign
[bd_travis_url]: http://travis-ci.org/apeman-app-labo/apeman-app-sign
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-app-labo/apeman-app-sign.svg?style=flat
[bd_license_url]: https://github.com/apeman-app-labo/apeman-app-sign/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-app-labo/apeman-app-sign
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-app-labo/apeman-app-sign.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-app-labo/apeman-app-sign.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-app-labo/apeman-app-sign
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-app-labo/apeman-app-sign.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-app-sign
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-app-sign.svg?style=flat
[bd_bower_badge_url]: https://img.shields.io/bower/v/apeman-app-sign.svg?style=flat

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

apeman app to handle sign.

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>

Add sign endpoints.

<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>
Installation
-----

```bash
$ npm install apeman-app-sign --save
```


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>
Usage
---------

1. Define an app within Apemanfile.js
2. Call the app via apeman app command.

**Apemanfile.js**
```javascript
/** This is an example Apemanfile to use apeman-app-sign */

"use strict";

const db = require('../../db'); // Instance of apeman-db

module.exports = {
    $pkg: {/*...*/},
    $apps: {
        // Define your own app.
        'my-app-01': {
            // Map url and handlers.
            '/sign': [
                require('apeman-app-sign')(
                    db.mode('User'),
                    db.mode('Sign'),
                    {
                        //Options
                    })
            ]
        }
    }
};
```

Then,
```bash
$ apeman app my-app-01 -p 3000
```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.Options.md.hbs" Start -->

<a name="section-doc-guides-03-options-md"></a>
Options
-------

| Key | Type | Default | Description |
| --- | ---- | --- | --- |
| userModel | string | 'User' | Name of user model. |
| signModel | string | 'Sign' | Name of sign model. |
| beforeSignget | function | noop() | Handler before signget. |
| beforeSignup | function | noop() | Handler before signup. |
| beforeSignin | function | noop() | Handler before signin. |
| beforeSignout | function | noop() | Handler before signout. |
| beforeSignmod | function | noop() | Handler before signmod. |
| beforeSigndel | function | noop() | Handler before signdel. |
| signinSchema | object | defaultSchema('signinSchema') | Schema for signin endpoint. |
| signupSchema | object | defaultSchema('signupSchema') | Schema for signup endpoint. |
| signmodSchema | object | defaultSchema('signmodSchema') | Schema for signmod endpoint. |
| signdelSchema | object | defaultSchema('signdelSchema') | Schema for signdel endpoint. |
| signdelSchema | object | defaultSchema('signdelSchema') | Schema for signdel endpoint. |
| signoutSchema | object | defaultSchema('signoutSchema') | Schema for signout endpoint. |
| saltLength | number | 24 | Length of salt. |
| signKey | string&#124;string[] | ['username', 'email'] | Key(s) of user to use as sign key. |
| format | string | 'json' | Response format like "json", "xml", etc. |
| passwordSpec | number | 'pdkdf2:120:84'] - Password algorithm, iterations, length.|



<!-- Section from "doc/guides/03.Options.md.hbs" End -->

<!-- Section from "doc/guides/04.Endpoints.md.hbs" Start -->

<a name="section-doc-guides-04-endpoints-md"></a>
Endpoints
---------

| url | METHOD |
| --- | ------ |
| **/signget** | GET |
| **/signup** | POST |
| **/signin** | POST |
| **/signout** | POST |
| **/signmod** | POST |
| **/signdel** | POST |


<!-- Section from "doc/guides/04.Endpoints.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-app-labo/apeman-app-sign/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman](https://github.com/apeman-labo/apeman)
+ [apeman-app](https://github.com/apeman-labo/apeman-app)
+ [apemandb](https://github.com/apeman-labo/apemandb)

<!-- Links End -->
