/**
 * Define digest function.
 * @function defineDigest
 */

"use strict";

const apemanpasswd = require('apemanpasswd'),
    apemanpromise = require('apemanpromise'),
    async = require('async');

/** @lends defineDigest */
function defineDigest(spec) {
    let passwd = apemanpasswd.fromSpecString(spec);

    function digest(password, salt) {
        return apemanpromise((resolve, reject) => {
            passwd.digest(password, salt, (err, hash) => {
                if (err) {
                    reject(err);
                } else {
                    resolve(hash);
                }
            });
        });
    }

    digest.newSalt = passwd.newSalt.bind(passwd);
    return digest;
}

module.exports = defineDigest;
