/**
 * @function doSigndel
 */
"use strict";

const apemanpromise = require('apemanpromise');

/** @lends doSigndel */
function doSigndel(User, Sign, signed) {
    return User.findById(signed.user.id)
        .then((user) => {
            return Sign
                .findAll({
                    where: {user_id: user.id}
                })
                .then((signs) => {
                    return apemanpromise.all(
                        signs.map((sign) => {
                            return sign.destroy();
                        })
                    );
                })
                .then(() => {
                    return user.destroy();
                });
        });
}

module.exports = doSigndel;
