/**
 * @function doSignout
 * @returns Promise
 */

"use strict";

/** @lends doSignout */
function doSignout(User, Sign, signed) {
    return Sign
        .findById(signed.id)
        .then((sign) => {
            if (!sign) {
                return null;
            }
            return User.findById(sign.get('id'))
                .then((user) => {
                    return sign.update({
                        signout_at: new Date()
                    }).then((sign) => {
                        let result = sign.toJSON();
                        result.user = user.toJSON();
                        return result;
                    });
                });
        });
}

module.exports = doSignout;

